
************************************
*Marcelo Torres 16/06/05 - Modificado el 4/6
************************************

#include "minigui.ch"
#include "hbclass.ch"

#xcommand WITH <oObject> DO => Self := <oObject>
#xcommand ENDWITH           => Self := NIL

#define xlContinuous        1    //lineas continuas
#define xlEdgeTop           8    //borde superior de la celda
#define xlAutomatic         -4105
#define xlEdgeBottom        9    //borde inferior
#define xlEdgeRight         10   //borde derecho
#define xlEdgeLeft          7    //borde izquierdo
#define xlInsideVertical    11 
#define xlInsideHorizontal  12
#define K_TAB               CHR(9)
#define xlHtml              44     //formato html
#define xlNormal            -4143 
#define xlThin              2      //linea fina
#define xlMedium            -4138  //linea mediana
#define xlSolid             1


Static nVeces  := 0
Static aColumna:={"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"}

CLASS TEXCEL FROM HBCLASS
*--------------------------------------------------

DATA aDatos           AS ARRAY     INIT {}
DATA aCabeceras       AS ARRAY     INIT {}
DATA aFormato         AS ARRAY     INIT {}
DATA oExcel           AS OBJECT
DATA oHoja            AS OBJECT
DATA lWrap            AS LOGICAL   INIT .f.
DATA lCierra          AS LOGICAL   INIT .F.
DATA aColSuma         AS ARRAY     INIT {}
DATA aColCuenta       AS ARRAY     INIT {}
DATA nFile_formato    AS NUMERIC   INIT 0
DATA cFile_saveas     AS CHARACTER INIT ""
DATA lVisible         AS LOGICAL   INIT .f.
DATA oActiveWorkBook  AS OBJECT  

Method NEW(cNombre,lCierra,lVisible)            Constructor
Method FUENTE(aPos,cNombreFuente,nTamano,lBold)
METHOD DRAWCONTORNO(aPos,nTrazo,lExt,lIntH,lIntV)
Method GENERA(aFormat,aHeader,aDatos,lWrap)
METHOD FUNCION(cFuncion,aCol,nFila)
METHOD SAVEAS(cFile)
METHOD SOMBRA(aCoordenadas)
METHOD AUTOFIT(aCols)
Method End()

END CLASS


*--------------------------------------------------
METHOD NEW(cNombre,lCierra,lVisible) CLASS TEXCEL
*--------------------------------------------------
 
**************************Creacion de la hoja

   ::oExcel := TOleAuto():New( "Excel.Application" )

   ::oActiveWorkBook:= ::oExcel:WorkBooks:Add()

   ::oHoja := ::oExcel:Get( "ActiveSheet" )
   
   ::lCierra  := IIF(Valtype(lCierra)  != "L",.f.,lCierra)
   ::lVisible := IIF(Valtype(lVisible) != "L",.f.,lVisible)
   
   IF cNombre != Nil
      ::oHoja:Name := cNombre
   Endif
      
**************************
   //////////////////////////////////Caracteres de Cabecera
   
**************************Armamos Cabeceras
   ::oHoja:Rows(1):Rowheight:=42
   
Return Self


//aFormat = array with format to each col
//aHeader = array with header name to each col
//aDatos  = array data
//lWrap   = wrap of cell (true or false)
*--------------------------------------------------
METHOD GENERA(aFormat,aHeader,aDatos,lWrap) CLASS TEXCEL 
*--------------------------------------------------

Local I              :=0
local x              :=0
Local nFilas         :=0
local cColumna       := ""
local cValor         := ""
local cCabecera      := ""
local cSetSuma  := cSetCuenta := ""
local cTempValor     := ""

*-------chequeamos los parametros---------*
If Valtype(aFormat) = "A"             //Formato
   ::aFormato    :=aFormat
Endif  

*-----------------------------------------*
IF ! empty(aHeader)                   //Header

   ::aCabeceras  := aHeader
   IF Valtype(lWrap) = "L"
      ::lWrap       := lWrap
   Endif
      
Endif

*-----------------------------------------*
If ! empty(adatos)                    //Datos
   ::aDatos:=adatos
Endif



*--------Formateamos las columnas---------*

For I = 1 to len(::aFormato)
    Do Case
      Case ::aFormato[I] == "N"
         ::oHoja:Columns(I):SET("NumberFormat","#######0")
      Case ::aFormato[I] == "ND"
         ::oHoja:Columns(I):SET("NumberFormat","###.##0,00")
      Case ::aFormato[I] == "D"
         ::oHoja:Columns(I):SET("NumberFormat","dd/mm/yy;@")
      Case ::aFormato[I] == "C"
        ::oHoja:Columns(I):SET("NumberFormat","@")
      OtherWise
        ::oHoja:Columns(I):SET("NumberFormat","General")  
    End Case   
   
    hb_idlestate() 
Next    

    
*------make the headers--------*   
For I = 1 to Len(::aCabeceras)  
     
   cCabecera += ::aCabeceras[I]+K_TAB
   nVeces := 0
   cColumna := Calcula_columna(I)+"1"
   
   ::oHoja:Range(cColumna):Set( "HorizontalAlignment", -4108 )
   ::oHoja:Cells(1,I):VerticalAlignment:=-4108    
          
   ::oHoja:Cells(1,I):WrapText:=::lWrap             
   hb_idlestate()      
Next

::oHoja:Cells(1,1):Select()
*----to clipboard----*
CopyClipboard(cCabecera)
*----paste in the excel page-----*
::oHoja:Paste()

*------------------------------------*

nVeces := 0
          
*-----upload the data-----*

   
   ///////////////////////////////Rellenar las celdas con los datos...
   ///////////////////////////////x = filas ; I = columnas

   
   For X = 1 to len(::aDatos) 
        
      aFila := ::aDatos[X]
      nFilas ++
      
      For I = 1 to len(aFila)
      
         Do Case
            Case Valtype(aFila[I]) = "N"
                cTempValor := Str(aFila[I])
                cValor += StrTran(cTempValor,".",",")+K_TAB     //ponemos la coma, sino no toma los decimales...
            Case Valtype(aFila[I]) = "D"
                cValor += dToc(aFila[I])+K_TAB
            Case Valtype(aFila[I]) = "L"
                cValor += IIF(aFila[I],"T","F")+K_TAB
            Case Valtype(aFila[I]) = "C"    
                cValor += aFila[I] + K_TAB
         End Case               
         
         Do Events
         
      Next    
      
      *----Salto de linea----*
      cValor += hb_osnewline()
      *------------------------------*
      
   Next   
 
   ::oHoja:Cells(2,1):Select()
      
   *----Mandar al clipboard----*
   CopyClipboard(cValor)
   *----Pegar en la hoja de calculo-----*
   ::oHoja:Paste()
             
   
RETURN


*-------------------------------------
METHOD AUTOFIT(aCols) CLASS TEXCEL
*-------------------------------------
local I := 0

   For I = 1 to len(aCols)
      IF aCols[I] = .t.
         ::oHoja:Columns( I ):AutoFit()         ////////Para que ajuste las columnas al tamao del texto...
      Endif   
   Next
   
   hb_idlestate()
    
Return Self
   

//aPos := fila1,col1,fila2,col2
*-------------------------------------
METHOD FUENTE(aPos,cNombreFuente,nTamano,lBold) CLASS TEXCEL
*-------------------------------------
local Col1      := Col2 := ""
local cRango    := ""
local oSelection

If Valtype(cNombreFuente) != "C"
   cNombreFuente := "VERDANA"
Endif 
If Valtype(nTamano) != "N"
   nTamano := 9
Endif 
IF Valtype(lBold) != "L"
   lBold := .f.
Endif
           
nVeces := 0

Col1 := Calcula_columna(aPos[2])+Alltrim(str(aPos[1]))
Col2 := Calcula_columna(aPos[4])+Alltrim(str(aPos[3]))

cRango := Col1+":"+Col2

oSelection := ::oHoja:Range(cRango)

WITH oSelection:Font DO
     ::Name := cNombreFuente
     ::Size := nTamano
     ::Bold := lBold
ENDWITH
           
Return Self

//aPos   = matriz con coordenada para crear rango(Row1,col1,Row2,col2)
//nTrazo = 1(fino),2(medio)
//lExt   = dibujar lineas exteriores
//lIntH  = dibujar lineas interiores horizontales
//lIntV  = dibujar lineas interiores verticales
*------------------------------------
METHOD DRAWCONTORNO(aPos,nTrazo,lExt,lIntH,lIntV) CLASS TEXCEL
*------------------------------------
local Col1      := Col2 := ""
local cRango    := ""
local oSelection
local nStylo    := IIF(Valtype(nTrazo) = "N", IIF(nTrazo = 2,xlMedium,xlThin) ,xlThin)

IIF(lExt = Nil,lExt := .f.,lExt)
IIF(lIntH = Nil,lIntH := .f.,lIntH)
IIF(lIntV = Nil,lIntV := .f.,lIntV)

   
nVeces := 0

Col1 := Calcula_columna(aPos[2])+Alltrim(str(aPos[1]))
Col2 := Calcula_columna(aPos[4])+Alltrim(str(aPos[3]))

cRango := Col1+":"+Col2

oSelection := ::oHoja:Range(cRango)
 
   IF lExt    //dibujamos lineas horizontales

      WITH oSelection:Borders(xlEdgeLeft) DO
        ::LineStyle  := xlContinuous
        ::Weight     := nStylo
        ::ColorIndex := xlAutomatic
      EndWith
      With oSelection:Borders(xlEdgeTop) DO
        ::LineStyle  := xlContinuous
        ::Weight     := nStylo
        ::ColorIndex := xlAutomatic
      EndWith
      With oSelection:Borders(xlEdgeBottom) DO
        ::LineStyle  := xlContinuous
        ::Weight     := nStylo
        ::ColorIndex := xlAutomatic
      EndWith
      With oSelection:Borders(xlEdgeRight) DO
        ::LineStyle  := xlContinuous
        ::Weight     := nStylo
        ::ColorIndex := xlAutomatic
      EndWith
    
   Endif 
   IF lIntV    //dibujamos lineas verticales
     *-------el contorno Interior Vertical---------*
     IF aPos[2] != aPos[4]
       With oSelection:Borders(xlInsideVertical) DO
          ::LineStyle  := xlContinuous
          ::Weight     := nStylo
          ::ColorIndex := xlAutomatic
       EndWith
     Endif
   Endif
   IF lIntH  
     *-----el contorno interior horizontal------* 
     IF aPos[1] != aPos[3]   
       With oSelection:Borders(xlInsideHorizontal) DO
          ::LineStyle  := xlContinuous
          ::Weight     := nStylo
          ::ColorIndex := xlAutomatic
       EndWith
     Endif
   Endif  
    *--------------------------------------------------*   

    Do Events

Return Self

//cfuncion = Nombre de la funcion a realizar
//aCol     = Nro. de columnas sobre las que se hara la funcion
//nFila    = Fila donde se volcaran los datos.
*-------------------------------------
METHOD FUNCION(cFuncion,aCol,nFila) CLASS TEXCEL
*-------------------------------------
local I 
local cColumna
local cSetSuma
local cSetCuenta

Do Case
   Case cFuncion == "SUMA"         //see the name of function in each languaje
      IF valtype(aCol) = "A"
         ::aColSuma := aCol
      Endif
   Case cFuncion == "CONTARA"     //see the name of function in each languaje
      IF Valtype(aCol) = "A"
         ::aColCuenta := aCol
      Endif
End Case

*----cargamos una suma de columnas------+   
   
   For Each I in ::aColSuma
      cColumna := Calcula_columna(I)
      cSetSuma := ALLTRIM("=SUMA(" + cColumna+ "2:" + cColumna + Alltrim(Str(nFila)) + ")")    
      ::oHoja:Cells(nFila + 3,I):SET("NumberFormat","General")
      ::oHoja:Cells(nFila + 3,I):Value := cSetSuma
      ::oHoja:Cells(nFila + 3,I):Interior:ColorIndex := 15
   Next
   
*------cargamos un contador de registros------*
   I := Nil
   
   For Each I in ::aColCuenta
      cColumna := Calcula_Columna(I)
      cSetCuenta := Alltrim("=CONTARA("+cColumna+ "2:" + cColumna + Alltrim(Str(nFila+1)) + ")") 
      ::oHoja:Cells(nFila + 3,I):SET("NumberFormat","General") 
      ::oHoja:Cells(nFila + 3,I):Value := cSetCuenta
      ::oHoja:Cells(nFila + 3,I):Interior:ColorIndex := 15
   Next
        
   
Return Self

//cFile = Debe incluir la extension
*--------------------------------
METHOD SAVEAS(cFile) CLASS TEXCEL
*--------------------------------
local cformato := ""

If Valtype(cFile) = "C"    //guardamos archivo...

  ::cFile_saveas := cFile
  cformato := Substr(cFile,-3)

  Do Case
     Case Upper(cFormato) == "XLS"
        ::nFile_formato := xlNormal
     Case Upper(cFormato) == "HTM" .or. Upper(cFormato) == "HTML"   
        ::nFile_formato := xlHtml
     Otherwise
        ::cFile_saveas := ""
  End Case         

Endif    
    
Return Self    

//aPos := fila1,col1,fila2,col2
*--------------------------------
METHOD SOMBRA(aPos) CLASS TEXCEL
*--------------------------------
local Col1 := Col2 := ""
local cRango := ""
local oSelection

nVeces := 0

Col1 := Calcula_columna(aPos[2])+Alltrim(str(aPos[1]))
Col2 := Calcula_columna(aPos[4])+Alltrim(str(aPos[3]))

cRango := Col1+":"+Col2

oSelection := ::oHoja:Range(cRango)

WITH oSelection:Interior() DO
        ::ColorIndex := 15
        ::Pattern    := xlSolid
ENDWITH

Do Events

Return Self


*--------------------------------
METHOD END() CLASS TEXCEL
*--------------------------------
   *-----guardamos el fichero, si se le dio nombre------*
   IF !Empty(::cFile_saveas)
     ::oActiveWorkBook:SaveAs(::cFile_saveas, ::nFile_formato,.f.,.f.)
   Endif 
   
   *------Show the file maked------*        
   ::oHoja:Cells( 1, 1 ):Select()
   ::oExcel:Visible := ::lVisible

   IF ::lCierra
      ::oExcel:Set( "DisplayAlerts", .f. )
      ::oExcel:Quit()
   Endif   
   
Self := Nil

Return Nil



*------------------------------------
Static Function CALCULA_COLUMNA(nValor)
*------------------------------------
Local cColumna:=""

//26 posiciones - Ver array aColumna declarado Static al principio.
IF Valtype(nValor) = "C"
   nValor:=Val(nValor)
Endif
   
IF nValor <= 26
   If nVeces = 0
      cColumna:=aColumna[nValor]
   Else
      cColumna:=aColumna[nVeces]+aColumna[nValor]   
   Endif
      
Else
   nVeces ++
   nValor   := nValor - 26
   cColumna := Calcula_Columna(nValor)
Endif      


Return cColumna


*---------for use the clipboard----------*

  #pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC ( COPYCLIPBOARD )
{
   HGLOBAL hglbCopy;
   char * lptstrCopy;
   char * cStr = hb_parc( 1 );
   int nLen = strlen( cStr );


   if ( !OpenClipboard( GetActiveWindow() ) )
      return;

   EmptyClipboard();

   hglbCopy = GlobalAlloc( GMEM_DDESHARE, (nLen+1) * sizeof(TCHAR) );
   if (hglbCopy == NULL)
   {
       CloseClipboard();
       return;
   }

   // Lock the handle and copy the text to the buffer.

   lptstrCopy = (char*) GlobalLock( hglbCopy );
   memcpy( lptstrCopy, cStr, nLen * sizeof(TCHAR));
   lptstrCopy[nLen] = (TCHAR) 0;    // null character
   GlobalUnlock(hglbCopy);

   // Place the handle on the clipboard.
   SetClipboardData( CF_TEXT, hglbCopy );

   CloseClipboard();
}

#pragma ENDDUMP
